%define anolis_release 3
%global gnulib_ver 20180203

Summary: Utility for modifying/upgrading files
Name: patch
Version: 2.7.6
Epoch: 1
Release: %{anolis_release}%{?dist}
License: GPLv3+
URL: https://savannah.gnu.org/projects/patch/
Source: https://ftp.gnu.org/gnu/patch/patch-%{version}.tar.xz

Patch0: patch-2.7.6-avoid-set_file_attributes-sign-conversion-warnings.patch
patch1: patch-2.7.6-test-suite-compatibility-fixes.patch
Patch2: patch-2.7.6-fix-korn-shell-incompatibility.patch
Patch3: patch-2.7.6-fix-segfault-with-mangled-rename-patch.patch
Patch4: patch-2.7.6-allow-input-files-to-be-missing-for-ed-style-patches.patch
Patch5: patch-CVE-2018-1000156.patch
Patch6: patch-2.7.6-CVE-2019-13638-invoked-ed-directly-instead-of-using-the-shell.patch
Patch7: patch-2.7.6-switch-from-fork-execlp-to-execute.patch
Patch8: patch-2.7.6-cleanups-in-do_ed_script.patch
Patch9: patch-2.7.6-avoid-warnings-gcc8.patch
Patch10: patch-2.7.6-check-of-return-value-of-fwrite.patch
Patch11: patch-2.7.6-fix-ed-style-test-failure.patch
Patch12: patch-2.7.6-dont-leak-temporary-file-on-failed-ed-style-patch.patch
Patch13: patch-2.7.6-dont-leak-temporary-file-on-failed-multi-file-ed-style-patch.patch
Patch14: patch-2.7.6-make-debug-output-more-useful.patch
Patch15: patch-2.7.6-CVE-2018-6952-fix-swapping-fake-lines-in-pch_swap.patch
Patch16: patch-2.7.6-improve_support_for_memory_leak_detection.patch
patch17: patch-2.7.6-skip-ed-test-when-the-ed-utility-is-not-installed.patch
Patch18: patch-2.7.6-abort_when_cleaning_up_fails.patch
Patch19: patch-2.7.6-crash-RLIMIT_NOFILE.patch
Patch20: patch-2.7.6-CVE-2019-13636-symlinks.patch
Patch21: patch-2.7.6-avoid-invalid-memory-access-in-context-format-diffs.patch
Patch22: patch-2.7.6-CVE-2018-17942.patch
Patch23: patch-2.7.6-failed_assertion.patch
Patch100: patch-selinux.patch

BuildRequires: ed
BuildRequires: libattr-devel
BuildRequires: libselinux-devel
BuildRequires: make gcc autoconf automake

Requires: ed

Provides: bundled(gnulib) = %{gnulib_ver}

%description
Patch is a common Linux utility used for creating, modifying and applying patches
to source code. It is used to update, fix or improve software applications and
operating systems. This tool compares two files and generates a patch file
containing the differences between them. This patch file can be used to apply
the same changes to other files or directories.

Patch operates on files using a diff file format that contains a set of
instructions for changing one file to another. The diff format denotes the
additions and deletions in a file using a plus sign (+) or a minus sign (-)
respectively.

When using patch, the user first creates a patch file using the diff utility,
which generates a patch file containing the differences between two files. The
patch file can then be applied to the original file, which will update it based
on the changes defined in the patch file.

Patch can be used to apply multiple patches to one or more files, as it can
process an entire directory of files at once. It also supports recursive
directory processing, which can save time when updating large software projects.

One of the benefits of using patch is that it creates a log of changes with the
original file, allowing users to track changes and their authors. This feature
is particularly useful for software development teams who need to track changes
made to their applications.

In summary, patch is a Linux tool used for creating, modifying, and applying
patches to source code. It can be used for updating, fixing or improving software
applications and operating systems, and it is often used by software development
teams to track changes made to their projects.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

%build
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE"
autoreconf
%configure --disable-silent-rules
%make_build

%check
make check

%install
%makeinstall

%generate_compatibility_deps

%files
%license COPYING
%dir %{abidir}
%{_bindir}/*
%{abidir}/patch-option.list
%{_mandir}/*/*

%files doc
%doc NEWS README

%changelog
* Thu Apr 13 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 2.7.6-3
- Optimize the spec

* Mon Feb 06 2023 Feng Su <sufeng@linux.alibaba.com> - 2.7.6-2
- add doc sub package
- add abi/api files

* Mon May 16 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.7.6-1
- Init from upstream version 2.7.6
